<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreatePropertyRoomRateChannelMappingTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('property_room_rate_channel_mapping', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->unsignedInteger('channel_id');
            $table->unsignedBigInteger('room_rate_mapping_id');

            $table->tinyInteger('status')->default(1);
            $table->unsignedInteger('created_by');
            $table->unsignedInteger('updated_by');
            $table->integer('created_at');
            $table->integer('updated_at');

            $table->foreign('created_by')->references('id')->on('user');
            $table->foreign('updated_by')->references('id')->on('user');
            $table->foreign('channel_id')->references('id')->on('property_channel');
            $table->foreign('room_rate_mapping_id')->references('id')->on('property_room_rate_mapping');
            $table->unique(['channel_id', 'room_rate_mapping_id'], 'room_rate_channel_unique');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('property_room_rate_channel_mapping');
    }
}
